﻿//***********************************************************************
//                                                                     
//   Gleiches Auswählen
//Description:Installiert Befehle im Kontextmenü um gleiche Objekte auszuwählen
//                                                                     
//   [Ver: 0.5]   [Autor: Gerald Singelmann]   [Modif: 12-08-31]
//   [Lang: DE]   [Getestet mit: InDesign CS5]   [Creat: 10-05-03]
//                                                                     
//   Bugs & Feedback : gerald{at}indesign-faq{dot}de      
//                     www.indesign-faq.de    
//                                                                     
// This program is free software; you can redistribute it and/or
// modify it under the terms of the GNU General Public License
// as published by the Free Software Foundation; either version 2
// of the License, or (at your option) any later version.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
//
//*********************************************************************

#targetengine "gs_same_as"
var myLayoutContextMenu = app.menus.item("$ID/RtMouseLayout");
var mySelectSubmenu = myLayoutContextMenu.submenus.item("Auswählen"); 
main();
function main(){
	var myLayoutContextMenu = app.menus.item("$ID/RtMouseLayout");

	//Create the event handler for the "beforeDisplay" event of the Layout context menu.
	var myBeforeDisplayListener = myLayoutContextMenu.addEventListener("beforeDisplay", myBeforeDisplayHandler, false);
}

function myBeforeDisplayHandler(myEvent){
	if(app.documents.length != 0){
		var is_ok;
		if(app.selection.length == 1){
			switch(app.selection[0].constructor.name){
				case "Image":
				case "Rectangle":
				case "Oval":
				case "Polygon":
				case "GraphicLine":
				case "TextFrame":
					is_ok = true;
					break;
				default:
					is_ok = false;
			}
		} else {
			is_ok = false;
		}
		if(myCheckForMenuItem(mySelectSubmenu, "Gleiche Füllfarbe") == false){
			myMakeMenuItem(mySelectSubmenu, "fill");
		}
		if(myCheckForMenuItem(mySelectSubmenu, "Gleiche Konturfarbe") == false){
			myMakeMenuItem(mySelectSubmenu, "stroke");
		}
		if(myCheckForMenuItem(mySelectSubmenu, "Gleiche Konturstärke") == false){
			myMakeMenuItem(mySelectSubmenu, "weight");
		}
		if(myCheckForMenuItem(mySelectSubmenu, "Gleiche Deckkraft") == false){
			myMakeMenuItem(mySelectSubmenu, "opacity");
		}
	
		if(is_ok){
			app.scriptMenuActions.item("Gleiche Füllfarbe").enabled = true;
			app.scriptMenuActions.item("Gleiche Konturfarbe").enabled = true;
			app.scriptMenuActions.item("Gleiche Konturstärke").enabled = true;
			app.scriptMenuActions.item("Gleiche Deckkraft").enabled = true;
		} else {
			app.scriptMenuActions.item("Gleiche Füllfarbe").enabled = false;
			app.scriptMenuActions.item("Gleiche Konturfarbe").enabled = false;
			app.scriptMenuActions.item("Gleiche Konturstärke").enabled = false;
			app.scriptMenuActions.item("Gleiche Deckkraft").enabled = false;
		}
	}
}
	function myMakeMenuItem(parentMenu, which){
		switch( which ) {
			case "fill":
				if(myCheckForScriptMenuItem("Gleiche Füllfarbe") == false){
					var mySameFillMenuAction = app.scriptMenuActions.add("Gleiche Füllfarbe");
					var mySameFillEventListener = mySameFillMenuAction.eventListeners.add("onInvoke", mySameFillEventHandler, false);
				}
				if (parentMenu.menuElements.length > 0 && parentMenu.menuElements.lastItem().constructor.name != "MenuSeparator") {
					parentMenu.menuSeparators.add();
				}
				var mySameFillMenuItem = parentMenu.menuItems.add(app.scriptMenuActions.item("Gleiche Füllfarbe"));
				break;
			case "stroke":
				if(myCheckForScriptMenuItem("Gleiche Konturfarbe") == false){
					var mySameStrokeMenuAction = app.scriptMenuActions.add("Gleiche Konturfarbe");
					var mySameStrokeEventListener = mySameStrokeMenuAction.eventListeners.add("onInvoke", mySameStrokeEventHandler, false);
				}
				var mySameStrokeMenuItem = parentMenu.menuItems.add(app.scriptMenuActions.item("Gleiche Konturfarbe"));
				break;
			case "weight":
				if(myCheckForScriptMenuItem("Gleiche Konturstärke") == false){
					var mySameWeightMenuAction = app.scriptMenuActions.add("Gleiche Konturstärke");
					var mySameWeightEventListener = mySameWeightMenuAction.eventListeners.add("onInvoke", mySameWeightEventHandler, false);
				}
				var mySameWeightMenuItem = parentMenu.menuItems.add(app.scriptMenuActions.item("Gleiche Konturstärke"));
				break;
			case "opacity":
				if(myCheckForScriptMenuItem("Gleiche Deckkraft") == false){
					var mySameOpacityMenuAction = app.scriptMenuActions.add("Gleiche Deckkraft");
					var mySameOpacityEventListener = mySameOpacityMenuAction.eventListeners.add("onInvoke", mySameOpacityEventHandler, false);
				}
				var mySameOpacityMenuItem = parentMenu.menuItems.add(app.scriptMenuActions.item("Gleiche Deckkraft"));
				break;
		}
		
		function mySameFillEventHandler(myEvent){
			if (app.selection.length == 1) {
				var thing = app.selection[0];
				var scope = thing.parent;
				try {
					var color = thing.fillColor;
				} catch(e) {
					alert("Das hat keine Füllfarbe");
					exit();
				}
				if (scope.hasOwnProperty("pageItems") == false) {
					alert("Markieren Sie ein einzelnes Objekt, das frei auf der Seite liegt oder in einer Gruppe steckt.");
					exit();
				}
				
				var things = get_things_by_fill(scope, color);
				app.select(things);
			}
			function get_things_by_fill( scope, color ) {
				var things_in_scope = new Array();
				var all_things = scope.pageItems.everyItem().getElements();
				for (var n = 0; n < all_things.length; n++) {
					var thing = all_things[n];
					if ( thing.pageItems.length > 0 ) {
						var nested_things = get_things_by_fill( thing, color );
						for (var m = 0; m < nested_things.length; m++) {
							things_in_scope.push(nested_things[m]);
						}
					}
					try {	// Gruppen haben keine Füllfarbe, können aber auch nicht abgefangen werden, weil thing ein pageItem ist
						if ( thing.fillColor == color) {
							things_in_scope.push(all_things[n]);
						}
					} catch(e) {
					//	$.writeln(e);
					}
				}
				return things_in_scope;
			}
		}
		function mySameStrokeEventHandler(myEvent){
			if (app.selection.length == 1) {
				var thing = app.selection[0];
				var scope = thing.parent;
				try {
					var color = thing.strokeColor;
				} catch(e) {
					alert("Das hat keine Konturfarbe");
					exit();
				}
				if (scope.hasOwnProperty("pageItems") == false) {
					alert("Markieren Sie ein einzelnes Objekt, das frei auf der Seite liegt oder in einer Gruppe steckt.");
					exit();
				}
				
				var things = get_things_by_stroke(scope, color);
				app.select(things);
			}
			function get_things_by_stroke( scope, color ) {
				var things_in_scope = new Array();
				var all_things = scope.pageItems.everyItem().getElements();
				for (var n = 0; n < all_things.length; n++) {
					var thing = all_things[n];
					if ( thing.pageItems.length > 0 ) {
						var nested_things = get_things_by_stroke( thing, color );
						for (var m = 0; m < nested_things.length; m++) {
							things_in_scope.push(nested_things[m]);
						}
					}
					try {	// Gruppen haben keine Füllfarbe, können aber auch nicht abgefangen werden, weil thing ein pageItem ist
						if ( thing.strokeColor == color) {
							things_in_scope.push(all_things[n]);
						}
					} catch(e) {
						//$.writeln(e);
					}
				}
				return things_in_scope;
			}
		}
		function mySameWeightEventHandler(myEvent){
			if (app.selection.length == 1) {
				var thing = app.selection[0];
				var scope = thing.parent;
				var weight = thing.strokeWeight;
				
				if (scope.hasOwnProperty("pageItems") == false) {
					alert("Markieren Sie ein einzelnes Objekt, das frei auf der Seite liegt oder in einer Gruppe steckt.");
					exit();
				}
				var things = get_things_by_stroke(scope, weight);
				app.select(things);
			}
			function get_things_by_stroke( scope, weight ) {
				var things_in_scope = new Array();
				var all_things = scope.pageItems.everyItem().getElements();
				for (var n = 0; n < all_things.length; n++) {
					var thing = all_things[n];
					if ( thing.pageItems.length > 0 ) {
						var nested_things = get_things_by_stroke( thing, weight );
						for (var m = 0; m < nested_things.length; m++) {
							things_in_scope.push(nested_things[m]);
						}
					}
					try {	// Gruppen haben keine Füllfarbe, können aber auch nicht abgefangen werden, weil thing ein pageItem ist
						if ( thing.strokeWeight == weight) {
							things_in_scope.push(all_things[n]);
						}
					} catch(e) {
						//$.writeln(e);
					}
				}
				return things_in_scope;
			}
		}
		function mySameOpacityEventHandler(myEvent){
			if (app.selection.length == 1) {
				var thing = app.selection[0];
				var scope = thing.parent;
				var opacity = thing.transparencySettings.blendingSettings.opacity;
				if (scope.hasOwnProperty("pageItems") == false) {
					alert("Markieren Sie ein einzelnes Objekt, das frei auf der Seite liegt oder in einer Gruppe steckt.");
					exit();
				}
				
				var things = get_things_by_opacity(scope, opacity);
				app.select(things);
			}
			function get_things_by_opacity( scope, opacity ) {
				var things_in_scope = new Array();
				var all_things = scope.pageItems.everyItem().getElements();
				for (var n = 0; n < all_things.length; n++) {
					var thing = all_things[n];
					if ( thing.pageItems.length > 0 ) {
						var nested_things = get_things_by_opacity( thing, opacity );
						for (var m = 0; m < nested_things.length; m++) {
							things_in_scope.push(nested_things[m]);
						}
					}
					try {	// Gruppen haben keine Füllfarbe, können aber auch nicht abgefangen werden, weil thing ein pageItem ist
						if ( thing.transparencySettings.blendingSettings.opacity == opacity) {
							things_in_scope.push(all_things[n]);
						}
					} catch(e) {
						//$.writeln(e);
					}
				}
				return things_in_scope;
			}
		}
	}
			
			
	function getSpread(theObj) {
		var theSpread = theObj;
		if (theSpread.hasOwnProperty("baseline")) {
			theSpread = theSpread.parentTextFrames[0];
			if (theSpread == null) {return undefined }
		}
		while (theSpread.constructor.name != "Spread") {
			var whatIsIt = theSpread.constructor.name;
			switch (whatIsIt) {
				case  "Character" :
					theSpread = theSpread.parentTextFrames[0];
					break;
				case "Application" :
					// must be overset, so ignore (probably impossible)
					return undefined;
			}
			theSpread = theSpread.parent;
		}
		return theSpread
	}
			
	function myCheckForMenuItem(myMenu, myString){
		var myResult = false;
		try{
			var myMenuItem = myMenu.menuItems.item(myString);
			myMenuItem.name;
			myResult = true
		}
		catch(myError){}
		//alert("Menu item found? " + myResult);
		return myResult;
	}
	function myCheckForScriptMenuItem(myString){
		var myResult = false;
		try{
			var myScriptMenuAction = app.scriptMenuActions.item(myString);
			myScriptMenuAction.name;
			myResult = true
		}
		catch(myError){}
		//alert("Script menu action found? " + myResult);
		return myResult;			
	}

